using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Web;
using System.Web.Configuration;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public class Paging
{
    private int _count = 0;

    public int TotalUsuarios()
    {
        return this._count;
    }

    public List<Usuario> ResgataUsuarios(int pageSize, int pageNumber)
    {
        List<Usuario> coll = new List<Usuario>();
        SqlConnection conn = new SqlConnection(
            WebConfigurationManager.ConnectionStrings["ConnString"].ConnectionString);
        SqlCommand cmd = new SqlCommand("CustomPaging", conn);

        cmd.CommandType = CommandType.StoredProcedure;
        cmd.Parameters.AddWithValue("@PageSize", pageSize);
        cmd.Parameters.AddWithValue("@PageNumber", pageNumber);
        cmd.Parameters.AddWithValue("@RETURN_VALUE", 0).Direction = 
            ParameterDirection.ReturnValue;

        SqlDataReader dr = null;
        try
        {
            conn.Open();
            dr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
            while (dr.Read())
            {
                Usuario u = new Usuario();
                u.Nome = dr.GetString(0);
                coll.Add(u);
            }
        }
        finally
        {
            if (dr != null)
                dr.Close();

            this._count = 
                Convert.ToInt32(cmd.Parameters["@RETURN_VALUE"].Value);
        }
        return coll;
    }
}