using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Web;
using System.Web.Configuration;
using System.Web.Security;
using System.Collections.Generic;

public class Usuarios
{
    public void Delete(int original_ID)
    {
        SqlConnection conn =
            new SqlConnection(
                WebConfigurationManager.ConnectionStrings["ConnString"].ConnectionString);
        SqlCommand cmd =
            new SqlCommand("DELETE FROM Usuario WHERE UsuarioID = @ID", conn);

        cmd.Parameters.AddWithValue("@ID", original_ID);

        try
        {
            conn.Open();
            cmd.ExecuteNonQuery();
        }
        finally
        {
            if (conn != null)
            {
                conn.Close();
            }
        }
    }

    public void Update(string nome, string email, int id) {
        SqlConnection conn =
            new SqlConnection(WebConfigurationManager.ConnectionStrings["ConnString"].ConnectionString);
        SqlCommand cmd = 
            new SqlCommand("UPDATE Usuario SET Nome = @Nome, Email = @Email WHERE UsuarioID = @ID", conn);

        cmd.Parameters.AddWithValue("@Nome", nome);
        cmd.Parameters.AddWithValue("@Email", email);
        cmd.Parameters.AddWithValue("@ID", id);

        try
        {
            conn.Open();
            cmd.ExecuteNonQuery();
        }
        finally {
            if (conn != null) {
                conn.Close();
            }
        }
    }

    public void Update(Usuario u)
    {
        SqlConnection conn =
            new SqlConnection(WebConfigurationManager.ConnectionStrings["ConnString"].ConnectionString);
        SqlCommand cmd =
            new SqlCommand("UPDATE Usuario SET Nome = @Nome, Email = @Email WHERE UsuarioID = @ID", conn);

        cmd.Parameters.AddWithValue("@Nome", u.Nome);
        cmd.Parameters.AddWithValue("@Email", u.Email);
        cmd.Parameters.AddWithValue("@ID", u.ID);

        try
        {
            conn.Open();
            cmd.ExecuteNonQuery();
        }
        finally
        {
            if (conn != null)
            {
                conn.Close();
            }
        }
    }

    public List<Usuario> ResgataUsuarios()
    {
        return ResgataUsuarios(string.Empty);
    }

    public List<Usuario> ResgataUsuarios(string coluna)
    {
        List<Usuario> coll = new List<Usuario>();
        SqlConnection conn = new SqlConnection(WebConfigurationManager.ConnectionStrings["ConnString"].ConnectionString);
        string query = "SELECT UsuarioID, Nome, Email FROM Usuario";

        if (coluna != string.Empty)
            query += " ORDER BY " + coluna;

        SqlCommand cmd = new SqlCommand(query, conn);
        SqlDataReader dr = null;
        try
        {
            conn.Open();
            dr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
            while (dr.Read())
            {
                Usuario u = new Usuario();
                u.ID = dr.GetInt32(0);
                u.Nome = dr.GetString(1);
                u.Email = dr.GetString(2);
                coll.Add(u);
            }
        }
        finally
        {
            if (dr != null)
                dr.Close();
        }
        return coll;
    }
}